unit hiEZColor;

interface

uses
  Kol,windows,Share,Debug,Win,Messages;

const
  MaxColor = 464;
  SColor1  = clCaptionText;//clWhite;
  SColor2  = cl3DLight;//clSilver;
  SColor3  = clBtnShadow;//clGray;
  SColor4  = clWindowText;//clBlack;
  COLOR_MENUHILIGHT = 29;
  COLOR_MENUBAR = 30;
  clSystemColor = $FF000000;
  clHotLight = TColor(clSystemColor or COLOR_HOTLIGHT);
  clGradientActiveCaption = TColor(clSystemColor or COLOR_GRADIENTACTIVECAPTION);
  clGradientInactiveCaption = TColor(clSystemColor or COLOR_GRADIENTINACTIVECAPTION);
  clMenuHighlight = TColor(clSystemColor or COLOR_MENUHILIGHT);
  clMenuBar = TColor(clSystemColor or COLOR_MENUBAR);


type
  TColorName  = array [0..MaxColor] of string;
  TColorRef   = array [0..MaxColor,0..2] of byte;
  TColorPrim  = array [0..15] of TColor;
  TColorSys   = array [0..30] of TColor;
  TColorSysN  = array [0..30] of string;

const
  Variance = 2;
  ColorName : TColorName =
    ('Alice Blue','Antique White','Antique White 1','Antique White 2','Antique White 3','Antique White 4','Aquamarine','Aquamarine 1','Aquamarine 2','Aquamarine 3','Aquamarine 4','Azure','Azure 1','Azure 2','Azure 3','Azure 4','Beige',
     'Bisque','Bisque 1','Bisque 2','Bisque 3','Bisque 4','Black','Blanched Almond','Blue','Blue 1','Blue 2','Blue 3','Blue 4','Blue Violet','Brown','Brown 1','Brown 2','Brown 3','Brown 4','Burlywood','Burlywood 1','Burlywood 2',
     'Burlywood 3','Burlywood 4','Cadet Blue','Cadet Blue 1','Cadet Blue 2','Cadet Blue 3','Cadet Blue 4','Chartreuse','Chartreuse 1','Chartreuse 2','Chartreuse 3','Chartreuse 4','Chocolate','Chocolate 1','Chocolate 2','Chocolate 3',
     'Chocolate 4','Coral','Coral 1','Coral 2','Coral 3','Coral 4','Cornflower Blue','Cornsilk','Cornsilk 1','Cornsilk 2','Cornsilk 3','Cornsilk 4','Aqua','Cyan 1','Cyan 2','Cyan 3','Cyan 4','Dark Blue','Dark Cyan','Dark Goldenrod',
     'Dark Goldenrod 1','Dark Goldenrod 2','Dark Goldenrod 3','Dark Goldenrod 4','Dark Green','Dark Grey','Dark Khaki','Dark Magenta','Dark Olive Green','Dark Olive Green 1','Dark Olive Green 2','Dark Olive Green 3','Dark Olive Green 4',
     'Dark Orange','Dark Orange 1','Dark Orange 2','Dark Orange 3','Dark Orange 4','Dark Orchid','Dark Orchid 1','Dark Orchid 2','Dark Orchid 3','Dark Orchid 4','Dark Red','Dark Salmon','Dark Sea Green','Dark Sea Green 1',
     'Dark Sea Green 2','Dark Sea Green 3','Dark Sea Green 4','Dark Slate Blue','Dark Slate Gray','Dark Slate Gray 1','Dark Slate Gray 2','Dark Slate Gray 3','Dark Slate Gray 4','Dark Turquoise','Dark Violet','Deep Pink','Deep Pink 1',
     'Deep Pink 2','Deep Pink 3','Deep Pink 4','Deep Sky Blue','Deep Sky Blue 1','Deep Sky Blue 2','Deep Sky Blue 3','Deep Sky Blue 4','Dim Grey','Dodger Blue','Dodger Blue 1','Dodger Blue 2','Dodger Blue 3','Dodger Blue 4',
     'Firebrick','Firebrick 1','Firebrick 2','Firebrick 3','Firebrick 4','Floral White','Forest Green','Gainsboro','Ghost White','Gold','Gold 1','Gold 2','Gold 3','Gold 4','Goldenrod','Goldenrod 1','Goldenrod 2','Goldenrod 3',
     'Goldenrod 4','Gray 81','Gray 91','Lime','Green 1','Green 2','Green 3','Green 4','Green Yellow','Silver','Grey 11','Grey 21','Grey 31','Grey 41','Gray','Grey 61','Grey 71','Honeydew','Honeydew 1','Honeydew 2','Honeydew 3','Honeydew 4',
     'Hot Pink','Hot Pink 1','Hot Pink 2','Hot Pink 3','Hot Pink 4','Indian Red','Indian Red 1','Indian Red 2','Indian Red 3','Indian Red 4','Ivory','Ivory 1','Ivory 2','Ivory 3','Ivory 4','Khaki 1','Khaki 2','Khaki 3','Khaki 4','Lavender',
     'Lavender Blush','Lavender Blush 1','Lavender Blush 2','Lavender Blush 3','Lavender Blush 4','Lawn Green','Lemon Chiffon','Lemon Chiffon 1','Lemon Chiffon 2','Lemon Chiffon 3','Lemon Chiffon 4','Light Blue','Light Blue 1',
     'Light Blue 2','Light Blue 3','Light Blue 4','Light Coral','Light Cyan','Light Cyan 1','Light Cyan 2','Light Cyan 3','Light Cyan 4','Light Goldenrod','Light Goldenrod 1','Light Goldenrod 2','Light Goldenrod 3','Light Goldenrod 4',
     'Light Gray','Light Green','Light Pink','Light Pink 1','Light Pink 2','Light Pink 3','Light Pink 4','Light Salmon','Light Salmon 1','Light Salmon 2','Light Salmon 3','Light Salmon 4','Light Sea Green','Light Sky Blue','Light Sky Blue 1',
     'Light Sky Blue 2','Light Sky Blue 3','Light Sky Blue 4','Light Slate Blue','Light Slate Gray','Light Steel Blue','Light Steel Blue 1','Light Steel Blue 2','Light Steel Blue 3','Light Steel Blue 4','Light Yellow','Light Yellow 1',
     'Light Yellow 2','Light Yellow 3','Light Yellow 4','Lime Green','Linen','Lt Goldenrod Yello','Fuchsia','Magenta 1','Magenta 2','Magenta 3','Magenta 4','Maroon','Maroon 1','Maroon 2','Maroon 3','Maroon 4','Medium Aquamarine','Medium Blue',
     'Medium Orchid','Medium Orchid 1','Medium Orchid 2','Medium Orchid 3','Medium Orchid 4','Medium Purple','Medium Purple 1','Medium Purple 2','Medium Purple 3','Medium Purple 4','Medium Sea Green','Medium Slate Blue','Medium Turquoise',
     'Medium Violet Red','Med Spring Green','Midnight Blue','Mint Cream','Misty Rose','Misty Rose 1','Misty Rose 2','Misty Rose 3','Misty Rose 4','Moccasin','Navajo White','Navajo White 1','Navajo White 2','Navajo White 3',
     'Navajo White 4','Navy','Old Lace','Olive Drab','Olive Drab 1','Olive Drab 2','Olive Drab 3','Olive Drab 4','Orange','Orange 1','Orange 2','Orange 3','Orange 4','Orange Red','Orange Red 1','Orange Red 2','Orange Red 3','Orange Red 4',
     'Orchid','Orchid 1','Orchid 2','Orchid 3','Orchid 4','Pale Goldenrod','Pale Green','Pale Green 1','Pale Green 2','Pale Green 3','Pale Green 4','Pale Turquoise','Pale Turquoise 1','Pale Turquoise 2','Pale Turquoise 3',
     'Pale Turquoise 4','Pale Violet Red','Pale Violet Red 1','Pale Violet Red 2','Pale Violet Red 3','Pale Violet Red 4','Papaya Whip','Peach Puff','Peach Puff 1','Peach Puff 2','Peach Puff 3','Peach Puff 4','Peru','Pink','Pink 1',
     'Pink 2','Pink 3','Pink 4','Plum','Plum 1','Plum 2','Plum 3','Plum 4','Powder Blue','Purple','Purple 1','Purple 2','Purple 3','Purple 4','Red','Red 1','Red 2','Red 3','Red 4','Rosy Brown','Rosy Brown 1','Rosy Brown 2','Rosy Brown 3',
     'Rosy Brown 4','Royal Blue','Royal Blue 1','Royal Blue 2','Royal Blue 3','Royal Blue 4','Saddle Brown','Salmon','Salmon 1','Salmon 2','Salmon 3','Salmon 4','Sandy Brown','Sea Green','Sea Green 1','Sea Green 2','Sea Green 3','Sea Green 4',
     'Seashell','Seashell 1','Seashell 2','Seashell 3','Seashell 4','Sienna','Sienna 1','Sienna 2','Sienna 3','Sienna 4','Sky Blue','Sky Blue 1','Sky Blue 2','Sky Blue 3','Sky Blue 4','Slate Blue','Slate Blue 1','Slate Blue 2','Slate Blue 3',
     'Slate Blue 4','Slate Gray 1','Slate Gray 2','Slate Gray 3','Slate Gray 4','Slate Grey','Snow','Snow 1','Snow 2','Snow 3','Snow 4','Spring Green','Spring Green 1','Spring Green 2','Spring Green 3','Spring Green 4','Steel Blue','Steel Blue 1',
     'Steel Blue 2','Steel Blue 3','Steel Blue 4','Tan','Tan 1','Tan 2','Tan 3','Tan 4','Thistle','Thistle 1','Thistle 2','Thistle 3','Thistle 4','Tomato','Tomato 1','Tomato 2','Tomato 3','Tomato 4','Turquoise','Turquoise 1','Turquoise 2',
     'Turquoise 3','Turquoise 4','Violet','Violet Red','Violet Red 1','Violet Red 2','Violet Red 3','Violet Red 4','Wheat','Wheat 1','Wheat 2','Wheat 3','Wheat 4','White','White Smoke','Yellow','Yellow 1','Yellow 2','Yellow 3','Yellow 4',
     'Yellow Green','Crap','Money Green','Sky Blue','Cream','Medium Gray','Maroon','Green','Olive','Purple','Teal');
  ColorRef : TColorRef =
    ((240,248,255),(250,235,215),(255,239,219),(238,223,204),(205,192,176),(139,131,120),(127,255,212),(127,255,212),(118,238,198),(102,205,170),(69,139,116),(240,255,255),(240,255,255),(224,238,238),(193,205,205),(131,139,139),
     (245,245,220),(255,228,196),(255,228,196),(238,213,183),(205,183,158),(139,125,107),(0,0,0),(255,235,205),(0,0,255),(0,0,255),(0,0,238),(0,0,205),(0,0,139),(138,43,226),(165,42,42),(255,64,64),(238,59,59),(205,51,51),(139,35,35),
     (222,184,135),(255,211,155),(238,197,145),(205,170,125),(139,115,85),(95,158,160),(152,245,255),(142,229,238),(122,197,205),(83,134,139),(127,255,0),(127,255,0),(118,238,0),(102,205,0),(69,139,0),(210,105,30),(255,127,36),
     (238,118,33),(205,102,29),(139,69,19),(255,127,80),(255,114,86),(238,106,80),(205,91,69),(139,62,47),(100,149,237),(255,248,220),(255,248,220),(238,232,205),(205,200,177),(139,136,120),(0,255,255),(0,255,255),(0,238,238),
     (0,205,205),(0,139,139),(0,0,139),(0,139,139),(184,134,11),(255,185,15),(238,173,14),(205,149,12),(139,101,8),(0,100,0),(169,169,169),(189,183,107),(139,0,139),(85,107,47),(202,255,112),(188,238,104),(162,205,90),(110,139,61),
     (255,140,0),(255,127,0),(238,118,0),(205,102,0),(139,69,0),(153,50,204),(191,62,255),(178,58,238),(154,50,205),(104,34,139),(139,0,0),(233,150,122),(143,188,143),(193,255,193),(180,238,180),(155,205,155),(105,139,105),
     (72,61,139),(47,79,79),(151,255,255),(141,238,238),(121,205,205),(82,139,139),(0,206,209),(148,0,211),(255,20,147),(255,20,147),(238,18,137),(205,16,118),(139,10,80),(0,191,255),(0,191,255),(0,178,238),(0,154,205),(0,104,139),
     (105,105,105),(30,144,255),(30,144,255),(28,134,238),(24,116,205),(16,78,139),(178,34,34),(255,48,48),(238,44,44),(205,38,38),(139,26,26),(255,250,240),(34,139,34),(220,220,220),(248,248,255),(255,215,0),(255,215,0),(238,201,0),
     (205,173,0),(139,117,0),(218,165,32),(255,193,37),(238,180,34),(205,155,29),(139,105,20),(207,207,207),(232,232,232),(0,255,0),(0,255,0),(0,238,0),(0,205,0),(0,139,0),(173,255,47),(190,190,190),(28,28,28),(54,54,54),(79,79,79),
     (105,105,105),(130,130,130),(156,156,156),(181,181,181),(240,255,240),(240,255,240),(224,238,224),(193,205,193),(131,139,131),(255,105,180),(255,110,180),(238,106,167),(205,96,144),(139,58,98),(205,92,92),(255,106,106),
     (238,99,99),(205,85,85),(139,58,58),(255,255,240),(255,255,240),(238,238,224),(205,205,193),(139,139,131),(255,246,143),(238,230,133),(205,198,115),(139,134,78),(230,230,250),(255,240,245),(255,240,245),(238,224,229),
     (205,193,197),(139,131,134),(124,252,0),(255,250,205),(255,250,205),(238,233,191),(205,201,165),(139,137,112),(173,216,230),(191,239,255),(178,223,238),(154,192,205),(104,131,139),(240,128,128),(224,255,255),(224,255,255),
     (209,238,238),(180,205,205),(122,139,139),(238,221,130),(255,236,139),(238,220,130),(205,190,112),(139,129,76),(211,211,211),(144,238,144),(255,182,193),(255,174,185),(238,162,173),(205,140,149),(139,95,101),(255,160,122),
     (255,160,122),(238,149,114),(205,129,98),(139,87,66),(32,178,170),(135,206,250),(176,226,255),(164,211,238),(141,182,205),(96,123,139),(132,112,255),(119,136,153),(176,196,222),(202,225,255),(188,210,238),(162,181,205),
     (110,123,139),(255,255,224),(255,255,224),(238,238,209),(205,205,180),(139,139,122),(50,205,50),(250,240,230),(250,250,210),(255,0,255),(255,0,255),(238,0,238),(205,0,205),(139,0,139),(176,48,96),(255,52,179),(238,48,167),
     (205,41,144),(139,28,98),(102,205,170),(0,0,205),(186,85,211),(224,102,255),(209,95,238),(180,82,205),(122,55,139),(147,112,219),(171,130,255),(159,121,238),(137,104,205),(93,71,139),(60,179,113),(123,104,238),(72,209,204),
     (199,21,133),(0,250,154),(25,25,112),(245,255,250),(255,228,225),(255,228,225),(238,213,210),(205,183,181),(139,125,123),(255,228,181),(255,222,173),(255,222,173),(238,207,161),(205,179,139),(139,121,94),(0,0,128),
     (253,245,230),(107,142,35),(192,255,62),(179,238,58),(154,205,50),(105,139,34),(255,165,0),(255,165,0),(238,154,0),(205,133,0),(139,90,0),(255,69,0),(255,69,0),(238,64,0),(205,55,0),(139,37,0),(218,112,214),(255,131,250),
     (238,122,233),(205,105,201),(139,71,137),(238,232,170),(152,251,152),(154,255,154),(144,238,144),(124,205,124),(84,139,84),(175,238,238),(187,255,255),(174,238,238),(150,205,205),(102,139,139),(219,112,147),(255,130,171),
     (238,121,159),(205,104,137),(139,71,93),(255,239,213),(255,218,185),(255,218,185),(238,203,173),(205,175,149),(139,119,101),(205,133,63),(255,192,203),(255,181,197),(238,169,184),(205,145,158),(139,99,108),(221,160,221),
     (255,187,255),(238,174,238),(205,150,205),(139,102,139),(176,224,230),(160,32,240),(155,48,255),(145,44,238),(125,38,205),(85,26,139),(255,0,0),(255,0,0),(238,0,0),(205,0,0),(139,0,0),(188,143,143),(255,193,193),
     (238,180,180),(205,155,155),(139,105,105),(65,105,225),(72,118,255),(67,110,238),(58,95,205),(39,64,139),(139,69,19),(250,128,114),(255,140,105),(238,130,98),(205,112,84),(139,76,57),(244,164,96),(46,139,87),
     (84,255,159),(78,238,148),(67,205,128),(46,139,87),(255,245,238),(255,245,238),(238,229,222),(205,197,191),(139,134,130),(160,82,45),(255,130,71),(238,121,66),(205,104,57),(139,71,38),(135,206,235),(135,206,255),
     (126,192,238),(108,166,205),(74,112,139),(106,90,205),(131,111,255),(122,103,238),(105,89,205),(71,60,139),(198,226,255),(185,211,238),(159,182,205),(108,123,139),(112,128,144),(255,250,250),(255,250,250),(238,233,233),
     (205,201,201),(139,137,137),(0,255,127),(0,255,127),(0,238,118),(0,205,102),(0,139,69),(70,130,180),(99,184,255),(92,172,238),(79,148,205),(54,100,139),(210,180,140),(255,165,79),(238,154,73),(205,133,63),(139,90,43),
     (216,191,216),(255,225,255),(238,210,238),(205,181,205),(139,123,139),(255,99,71),(255,99,71),(238,92,66),(205,79,57),(139,54,38),(64,224,208),(0,245,255),(0,229,238),(0,197,205),(0,134,139),(238,130,238),(208,32,144),(255,62,150),
     (238,58,140),(205,50,120),(139,34,82),(245,222,179),(255,231,186),(238,216,174),(205,186,150),(139,126,102),(255,255,255),(245,245,245),(255,255,0),(255,255,0),(238,238,0),(205,205,0),(139,139,0),(154,205,50),(192,160,0),
     (192,220,192),(166,202,240),(255,251,240),(160,160,164),(128,0,0),(0,128,0),(128,128,0),(128,0,128),(0,128,128));
  ColorPrim : TColorPrim =
    (clBlack,clMaroon,clGreen,clOlive,clNavy,clPurple,clTeal,clGray,clSilver,clRed,clLime,clYellow,
     clBlue,clFuchsia,clAqua,clWhite);
  ColorSys : TColorSys =
    (clScrollBar,clBackGround,clActiveCaption,clInactiveCaption,clMenu,clWindow,clWindowFrame,clMenuText,
     clWindowText,clCaptionText,clActiveBorder,clInactiveBorder,clAppWorkspace,clHighLight,clHighLightText,
     clBtnFace,clBtnShadow,clGrayText,clBtnText,clInactiveCaptionText,clBtnHighLight,cl3DDkShadow,cl3DLight,
     clInfoText,clInfoBk,clNone,clHotLight,clGradientActiveCaption,clGradientInactiveCaption,clMenuHighlight,
     clMenuBar);
  ColorSysN : TColorSysN =
    ('Scrollbar','Background','Active Caption','Inactive Caption','Menu','Window','Windowframe','Menu Text',
     'Window Text','Caption Text','Active Border','Inactive Border','Application Workspace','Highlight','Highlight Text',
     'Button Face','Button Shadow','Gray Text','Button Text','Inactive Caption Text','Button Highlight','cl3DDkShadow','3D Light',
     'Info Text','Info Background','None','Hot Light','Gradient Active Caption','Gradient Inactive Caption','Menu Highlight',
     'Menu Bar');

type
  TColorSyn = record
    ColDiff : byte;
    ColName : string;
  end;
  TColorType   = (ctValues,ctSystem,ctPrimary);
  TRGBArray    = array[0..32767] OF TRGBTriple;
  pRGBArray    = ^TRGBArray;
  TSelect      = (Col1,Col2,Col3,RBox,GBox,BBox,sel,none,SPBox);
  TShowType    = (stButton,stColorBox,stFlat);

  PEZColor  = ^THIEZColor;
  THIEZColor = class(THIWin)
  private
    Points       : array [0..6] of TPoint;
    Select       : TSelect;
    Side         : integer;
    Count        : integer;
    OldSize      : integer;
    Marker       : integer;
    FBack        : TColor;
    FNewCol      : TColor;
    FColType     : TColorType;
    SysCol       : integer;
    Bitmap       : Kol.PBitmap;
    Temp         : Kol.PBitmap;
    procedure DrawRGB;
    procedure DrawRects;
    function  ColorScheme(Intensity:Double):TColor;
    procedure RGBToHSV (const R,G,B:double;var H,S,V:double);
    procedure RGBToHLS(const R,G,B:double;var H,L,S:double);
    procedure SetSize(Size:integer);
    procedure SetBack(value:TColor);
    procedure SetNew(Value:TColor);
    procedure SetBmp;
    function  GetColorName(Col:TColor):TColorSyn;
    procedure SetColType(Value:TColorType);
    procedure GetSysCol(X,Y:integer);
    procedure GetPriCol(X,Y:integer);

    procedure onMouseDown(Sender: PControl; var Mouse: TMouseEventData);
    procedure onMouseUp(Sender: PControl; var Mouse: TMouseEventData);
    procedure onMouseMove(Sender: PControl; var Mouse: TMouseEventData);

    procedure Paint(Sender: PControl; DC: HDC);
  public
    _event_onSelectColor: THI_Event;

    procedure Init; override;
    destructor Destroy; override;
    procedure _work_doVisible(var _Data: TData; Index: word);
    procedure _work_doEnabled(var _Data: TData; Index: word);
    procedure _var_CurrentColor(var _Data: TData; Index: word);
    procedure _var_R(var _Data:TData; Index: word);
    procedure _var_G(var _Data:TData; Index: word);
    procedure _var_B(var _Data:TData; Index: word);
    procedure _var_HexColor(var _Data:TData; Index: word);

    property BackGround   : TColor        read FBack          write SetBack;
    property Selected     : TColor        read FNewCol        write SetNew;
    property ColorType    : TColorType    read FColType       write SetColType;
  end;

implementation

function GetHexColor(AColor: TColor): String;
begin
  Result := Int2Hex(GetBValue(AColor), 2) + Int2Hex(GetGValue(AColor), 2) + Int2Hex(GetRValue(AColor), 2);
end;

procedure THIEZColor._work_doVisible;
begin
  Control.Visible := ReadBool(_Data);
  Control.Invalidate;
end;

procedure THIEZColor._work_doEnabled;
begin
  Control.Enabled := ReadBool(_Data);
  Control.Invalidate;
end;

procedure THIEZColor._var_CurrentColor;
begin
  dtInteger(_Data,Selected);
end;

procedure THIEZColor._var_R;
begin
  dtInteger(_Data,GetRValue(Selected));
end;

procedure THIEZColor._var_G;
begin
  dtInteger(_Data,GetGValue(Selected));
end;

procedure THIEZColor._var_B;
begin
  dtInteger(_Data,GetBValue(Selected));
end;

procedure THIEZColor._var_HexColor;
begin
  dtString(_Data,GetHexColor(Selected));
end;


// Returns the corresponding 24-bit color if Col is a system color (negative value)
function Norm24BitCol(Col:TColor):TColor;
asm
    cmp  eax,0
    jge  @End
    add  eax,$80000000
    push eax
    call getsyscolor
    @End:
end;

procedure THIEZColor.Init;
begin
  //Control := NewPanel(FParent,esLowered);
  Control := NewPaintBox(FParent);
  Control.DoubleBuffered := True;
  Control.GetWindowHandle;
  Control.Show;
  inherited;
  //Control.width := 400;
  Marker := 2;
  Control.Height := Control.Width;
  OldSize := Control.Width;
  Side := 50;
  SysCol := -1;
  FBack := _prop_Color;

  Select := none;
  FNewCol := $008D008D;

  Bitmap := NewBitmap(Control.Width,Control.Width);
  Temp := NewBitmap(Control.Width,Control.Width);
  SetBmp;
  Count := 0;

  Control.onMouseMove := onMouseMove;
  Control.onMouseDown := onMouseDown;
  Control.onMouseUp := onMouseUp;
  Control.OnPaint := Paint;
end;

destructor THIEZColor.Destroy;
begin
  Bitmap.Free;
  Temp.Free;
  inherited Destroy;
end;

procedure THIEZColor.Paint(Sender: PControl; DC: HDC);
begin
  Bitmap.Canvas.Font.Assign(Control.Font);
  Temp.Canvas.Font.Assign(Control.Font);
  if OldSize <> Control.Width then SetSize(Control.Width);
  DrawRGB;
  DrawRects;
end;

procedure THIEZColor.SetBmp;
begin
  Bitmap.Width := Control.Width;
  Bitmap.Height := Control.Width;
  Temp.Width := Control.Width;
  Temp.Height := Control.Width;
  Bitmap.PixelFormat := pf24Bit;
  Temp.PixelFormat := pf24Bit;
end;

procedure THIEZColor.SetNew(value:TColor);
var
  I : integer;
begin
  FNewCol := Value;
  SysCol := -1;
  FColType := ctValues;
  for I := 0 to 30 do if (ColorSys[I] = Value) then SysCol := I;
  if (SysCol > -1) then FColType := ctSystem
  else for I := 0 to 15 do if (Value = ColorPrim[I]) then FColType := ctPrimary;
  if (Temp.Width > 1) then begin
    DrawRGB;
    DrawRects;
  end;
end;

procedure THIEZColor.SetBack(value:TColor);
begin
  FBack := value;
  SetSize(Control.Width);
  DrawRGB;
  DrawRects;
end;

procedure THIEZColor.SetColType(Value:TColorType);
begin
  FColType := value;
  DrawRGB;
  DrawRects;
end;

procedure THIEZColor.SetSize(Size:integer);
begin
  Count := 0;
  if Size > 560 then begin
    if Control.Align = caClient then Control.Align := caNone;
    Marker := 3;
    Control.width := 560;
    Bitmap.Canvas.Font.FontHeight := 8;
    Temp.Canvas.Font.FontHeight := 8;
  end else if (Size < 230) and (Size >= 205) then begin
    Marker := 2;
    Bitmap.Canvas.Font.FontHeight := 7;
    Temp.Canvas.Font.FontHeight := 7;
  end else if (Size < 205) and (Size >= 180) then begin
    Marker := 2;
    Bitmap.Canvas.Font.FontHeight := 6;
    Temp.Canvas.Font.FontHeight := 6;
  end else if Size < 180 then Control.width := 180
  else if (Size < 560) and (Size >= 330) then begin
    Marker := 3;
    Bitmap.Canvas.Font.FontHeight := 8;
    Temp.Canvas.Font.FontHeight := 8;
  end else begin
    Marker := 2;
    Bitmap.Canvas.Font.FontHeight := 8;
    Temp.Canvas.Font.FontHeight := 8;
  end;

  Control.Height := Control.Width;
  OldSize := Control.Width;
  Side := 50;

  Select := none;
  SetBmp;
end;

procedure THIEZColor.DrawRGB;
var
  x,y,a,b,c,d,f,g,h,i,j,k,w:integer;
  Row : pRGBArray;
  corr,amount : Double;
  rg : TRGBTriple;
  add : byte;
  //----------
  function  ColorToRGBTriple(const FNewCol:  TColor):  TRGBTriple;
  begin
    with Result do begin
      rgbtRed   := GetRValue(FNewCol);
      rgbtGreen   := GetGValue(FNewCol);
      rgbtBlue   := GetBValue(FNewCol)
    end;
  end;
  //----------
begin

  if (Count = 0) then begin
    w := Control.Width-Side;
    corr := w/2/255;
    c := Trunc(w/2);
    d := Trunc(w*(sqrt(0.75)-1)/2);
    f := Trunc(w+d*1.5);
    g := w-1;
    h := g-f;
    i := Trunc(w/20);
    j := Trunc(w/50);
    k := 1;

    // Background
    Temp.Canvas.Brush.BrushStyle := bsSolid;
    Temp.Canvas.Brush.Color := FBack;
    Temp.Canvas.FillRect(MakeRect(0,0,Control.Width,Control.Width+50));
    // Bars
    for y := i to g - i do begin
      Row := Temp.Scanline[y];
      for x := f to g do begin
         if (x < h/3 + f) and (y <> i) then with Row[x-1] do begin
           rgbtRed   := 255 - Trunc(255*(y-i)/(Control.Width-50-i*2));
           rgbtGreen := 0;
           rgbtBlue  := 0;
         end else if (x >= h/3 + f) and (x < h*2/3 + f) and (y <> i) then with Row[x-1] do begin
           rgbtRed   := 0;
           rgbtGreen := 255 - Round(255*(y-i)/(Control.Width-50-i*2));
           rgbtBlue  := 0;
         end else if (y <> i) then with Row[x-1] do begin
           rgbtRed   := 0;
           rgbtGreen := 0;
           rgbtBlue  := 255 - Round(255*(y-i)/(Control.Width-50-i*2));
         end;
      end;
    end;

    // Right
    for y := 0 to 255 do begin
       for x := 0 to 255 do begin
          b := Trunc(corr*(y + x*0.5))+k;
          a := Trunc(corr*(x*sqrt(0.75)))+c+d+j;
          Row := Temp.Scanline[b];
          with Row[a] do begin
            rgbtRed   := 0;
            rgbtGreen := x;
            rgbtBlue  := 255-y;
          end;
       end;
    end;

    // Left
    for y := 0 to 255 do begin
      for x := 0 to 255 do begin
         b := Trunc(corr*(y-x*0.5))+Trunc(Corr*255/2)+k;
         a := Trunc(corr*(x*sqrt(0.75)))+c-Trunc(Sqrt(0.75)*Corr*255)+d+j;
         Row := Temp.Scanline[b];
         with Row[a] do begin
           rgbtRed   := 255-x;
           rgbtGreen := 0;
           rgbtBlue  := 255-y;
         end;
      end;
    end;

    // Bottom
    for y := 0 to 255 do begin
      for x := 0 to 255 do begin
          b := Trunc(corr*(x*0.5+y*0.5-Y))+c+Trunc(Corr*255/2)+k;
          a := Trunc(corr*(x*sqrt(0.75)+y*sqrt(0.75)-1))+c-Trunc(Sqrt(0.75)*Corr*255)+d+j;
          Row := Temp.Scanline[b];
          with Row[a] do begin
            rgbtRed   := 255-y;
            rgbtGreen := x;
            rgbtBlue  := 0;
          end;
      end;
    end;

    for y := 0 to w+49 do begin
      Row := Temp.Scanline[y];
      for x := w to w+44 do begin
         rg := ColorToRGBTriple(ColorScheme(y/(w+50)));
         if x < w+22 then begin
           amount := (x-w)/21;
           add := 0;
         end else begin
           amount := 1-(x-w-22)/22;
           add := 255;
         end;
         with rg do begin
           rgbtRed   := Trunc(add + (rgbtRed   - add)*Amount);
           rgbtGreen := Trunc(add + (rgbtGreen - add)*Amount);
           rgbtBlue  := Trunc(add + (rgbtBlue  - add)*Amount);
         end;
         Row[x] := rg;
      end;
      for x := w+44 to w+50 do begin
        amount := (y)/(w+48);
        add    := 255;
        rg := ColorToRGBTriple(clBlack);
        with rg do begin
          rgbtRed   := add + Trunc((rgbtRed   - add)*Amount);
          rgbtGreen := add + Trunc((rgbtGreen - add)*Amount);
          rgbtBlue  := add + Trunc((rgbtBlue  - add)*Amount);
        end;
        Row[x] := rg;
      end;
    end;
    with Temp.Canvas{$ifndef F_P}^{$endif} do begin
      Pen.PenWidth := 1;
      Pen.Color := clBlack;//SColor4;
      MoveTo(c+d+j,k);                                                // Blue
      LineTo(c+d+j,c+k);
      MoveTo(c-Trunc(Sqrt(0.75)*Corr*255)+d+j,c+Trunc(Corr*255/2)+k); // Red
      LineTo(c+d+j,c+k);
      MoveTo(c+Trunc(Sqrt(0.75)*Corr*255)+d+j,C+Trunc(Corr*255/2)+k); // Green
      LineTo(c+d+j,c+k);

      Brush.Color := FNewCol;
      FillRect(MakeRect(j,j,-d*2+j,-d*2+j));
    end;
    Count := 1;
  end;

  Temp.Draw(Control.Canvas.Handle,0,0);
end;

procedure THIEZColor.DrawRects;
var
  c,d,f,g,h,i,j,k,l,m,n,p,u,v,w,z1,z2,z3,z4,Col1,Col2,Col3,fs,a,b,rw,rh:integer;
  x1,x2,x3,corr : Double;
  Col : TColor;
begin
  Col := Norm24BitCol(FNewCol);
  w := Control.Width-Side;
  corr := w/2/255;
  c := Trunc(w/2);
  d := Trunc(w*(sqrt(0.75)-1)/2);
  f := Trunc(w+ d*1.5);
  g := w-1;
  h := g-f;
  i := Trunc(w/20);
  j := Trunc(w/50);
  k := 1;
  l := marker;
  m := g-i*2;
  n := Trunc(c-c*GetBValue(Col)/255);

  Col1 := g-i-Trunc(m*GetRValue(Col)/255);
  Col2 := g-i-Trunc(m*GetGValue(Col)/255);
  Col3 := g-i-Trunc(m*GetBValue(Col)/255);

  z1 := Trunc(c-(GetRValue(Col)/255)*(Sqrt(0.75)*Corr*255)+d+j);
  Z2 := Trunc(c+(GetRValue(Col)/255)*(Corr*255/2)+k);
  z3 := Trunc(c+(GetGValue(Col)/255)*(Sqrt(0.75)*Corr*255)+d+j);
  Z4 := Trunc(c+(GetGValue(Col)/255)*(Corr*255/2)+k);

  Points[0].y := Col1;
  Points[1].y := Col2;
  Points[2].y := Col3;
  Points[3].x := c+d+j; // Blue
  Points[3].y := n;
  Points[4].x := Z1;    // Red
  Points[4].y := Z2;
  Points[5].x := Z3;    // Green
  Points[5].y := Z4;


  with Bitmap.Canvas{$ifndef F_P}^{$endif} do begin
    Temp.Draw(Handle,0,0);
    // Bars
    Pen.Color := clWhite;//SColor1;
    Brush.BrushStyle := bsClear;
    Rectangle(f-1,Col1-l,Trunc(h/3+f),Col1+l);
    Rectangle(Trunc(h/3+f),Col2-l,Trunc(h*2/3+f),Col2+l);
    Rectangle(Trunc(h*2/3+f),Col3-l,g,Col3+l);

    // Lines
    Pen.Color := clBlack;//SColor4;

    MoveTo(c+d+j,n);
    LineTo(Z1,Z2-c+n);

    MoveTo(c+d+j,n);
    LineTo(Z3,Z4-c+n);

    MoveTo(Z1,Z2-c+n);
    LineTo(Z1,Z2);

    MoveTo(Z3,Z4-c+n);
    LineTo(Z3,Z4);

    MoveTo(Z1,Z2);
    LineTo(Z1+Z3-c-d-j,Z2+Z4-c);

    MoveTo(Z3,Z4);
    LineTo(Z3+Z1-c-d-j,Z4+Z2-c);

    MoveTo(Z1,Z2-c+n);
    LineTo(Z1+Z3-c-d-j,Z2+Z4+n-c-c);

    MoveTo(Z3,Z4-c+n);
    LineTo(Z1+Z3-c-d-j,Z2+Z4+n-c-c);

    MoveTo(Z1+Z3-c-d-j,Z2+Z4-c);
    LineTo(Z1+Z3-c-d-j,Z2+Z4+n-c-c);

    // Fields
    Pen.Color := clSilver;//SColor2;
    Rectangle(c+d+j-l,n-l,c+d+j+l,n+l);   // Blue
    Rectangle(Z1-l,Z2-l,Z1+l,Z2+l);       // Red
    Rectangle(Z3-l,Z4-l,Z3+l,Z4+l);       // Green


    Pen.Color := clWhite;//SColor1;
    Brush.BrushStyle := bsSolid;
    Ellipse(Z1+Z3-c-d-j-l,Z2+Z4+n-c-c-l,Z1+Z3-c-d-j+l,Z2+Z4+n-c-c+l);

    if FColType = ctValues then begin
      // Set Color values
      u := TextHeight('I');
      v := TextWidth('G')*2;
      p := TextWidth('55555555');
      RGBToHSV(GetRValue(Col),GetGValue(Col),GetBValue(Col),x1,x2,x3);

      Brush.BrushStyle := bsClear;
      if (FBack <> Norm24BitCol(SColor2)) then Font.Color := SColor2 else Font.Color := SColor3;

      TextOut(j,g+6,'R');
      TextOut(j,g+8+u,'G');
      TextOut(j,g+10+U*2,'B');
      TextOut(j+p,g+6,'H');
      TextOut(j+p,g+8+u,'S');
      TextOut(j+p,g+10+U*2,'V');
      TextOut(j+p+p,g+6,'H');
      TextOut(j+p+p,g+8+u,'L');
      TextOut(j+p+p,g+10+U*2,'S');
      TextOut(j+p*3,g+6,'R');
      TextOut(j+p*3,g+8+u,'G');
      TextOut(j+p*3,g+10+U*2,'B');

      if (FBack <> Norm24BitCol(SColor1)) then Bitmap.Canvas.Font.Color := SColor1 else Bitmap.Canvas.Font.Color := SColor2;

      TextOut(j+v,g+6,Int2Str(GetRValue(Col)));
      TextOut(j+v,g+8+u,Int2Str(GetGValue(Col)));
      TextOut(j+v,g+10+U*2,Int2Str(GetBValue(Col)));
      TextOut(j+v+p,g+6,Int2Str(trunc(x1)));
      TextOut(j+v+p,g+8+u,Int2Str(trunc(x2)));
      TextOut(j+v+p,g+10+U*2,Int2Str(trunc(x3)));

      RGBToHLS(GetRValue(Col),GetGValue(Col),GetBValue(Col),x1,x2,x3);
      TextOut(j+v+p+p,g+6,Int2Str(trunc(x1)));
      TextOut(j+v+p+p,g+8+u,Int2Str(trunc(x2)));
      TextOut(j+v+p+p,g+10+U*2,Int2Str(trunc(x3)));

      TextOut(j+v+p*3,g+6,Int2Hex(GetRValue(Col),2));
      TextOut(j+v+p*3,g+8+u,Int2Hex(GetGValue(Col),2));
      TextOut(j+v+p*3,g+10+U*2,Int2Hex(GetBValue(Col),2));
    end;

    if FColType = ctSystem then begin
      rw := (w-1) div 11;
      rh := (50-K-1) div 3;
      for a := 0 to 30 do begin
         Brush.BrushStyle := bsSolid;
         Brush.Color := GetSysColor(a);
         if (FBack <> Norm24BitCol(SColor3)) then Pen.Color := SColor3 else Pen.Color := SColor2;
         case a mod 3 of
            0 : Rectangle((a div 3)*rw,w+k+1,(a div 3)*rw+rw+1,w+k+2+rh);
            1 : Rectangle((a div 3)*rw,w+k+1+rh,(a div 3)*rw+rw+1,w+k+2+rh*2);
            2 : Rectangle((a div 3)*rw,w+k+1+2*rh,(a div 3)*rw+rw+1,w+k+1+rh*3);
         end;
      end;
      Brush.BrushStyle := bsClear;
      Rectangle(0,w+k+1,w,w+50);
    end;

    if FColType = ctPrimary then begin
      rw := (w-1) div 8;
      rh := (50-K-1) div 2;
      for a := 0 to 15 do begin
         Brush.BrushStyle := bsSolid;
         Brush.Color := ColorPrim[a];
         Pen.Color   := SColor2;
         if (FBack <> Norm24BitCol(SColor3)) then Pen.Color := SColor3 else Pen.Color := SColor2;
         case a mod 2 of
            0 : Rectangle((a div 2)*rw,w+k+1,(a div 2)*rw+rw+1,w+k+2+rh);
            1 : Rectangle((a div 2)*rw,w+k+1+rh,(a div 2)*rw+rw+1,w+k+2+rh*2);
         end;
      end;
      Brush.BrushStyle := bsClear;
      Rectangle(0,w+k+1,w,w+50);
    end;

    // Rects
    Brush.BrushStyle := bsClear;
    Pen.Color := SColor3;
    if (FBack <> Norm24BitCol(SColor3)) then Pen.Color := SColor3 else Pen.Color := SColor2;
    Rectangle(0,0,w,w+k+2);
    Rectangle(0,w+k+1,w,w+50);
    Rectangle(w-1,0,w+50,w+50);
    Brush.BrushStyle := bsSolid;
    Brush.Color := SColor4;
    Rectangle(w-i,w+k+1-i,w,w+k+2);
    Brush.BrushStyle := bsSolid;
    Brush.Color := SColor3;
    Pen.Color   := SColor3;
    i := i div 2;
    Ellipse(w-i-(i div 2),w+k+1-(i div 2),w-(i div 2),w+k+1-i-(i div 2));

    // Color name
    if (FBack <> Norm24BitCol(clWhite)) then Bitmap.Canvas.Font.Color := SColor1 else Bitmap.Canvas.Font.Color := SColor2;
    Brush.BrushStyle := bsClear;
    Fs := Bitmap.Canvas.Font.FontHeight;
    Bitmap.Canvas.Font.FontHeight := Round(Fs*7/8);
    u := TextHeight('I');
    if (FNewCol < 0) or ((FColType = ctSystem) and (SysCol > -1)) then begin
      if (SysCol > -1) and (FColType = ctSystem) then TextOut(k,w+k-u,ColorSysN[SysCol])
      else for a := 0 to 30 do if (ColorSys[a] = FNewCol) then TextOut(k,w+k-u,ColorSysN[a]);
    end else with GetColorName(Col) do begin
      if (ColDiff = 1) then Bitmap.Canvas.Font.Color := SColor3;
      TextOut(k,w+k-u,ColName);
    end;
    Bitmap.Canvas.Font.FontHeight := Fs;

    // Preview color
    Brush.BrushStyle := bsSolid;
    Brush.Color := Col;
    FillRect(MakeRect(j,j,-d*2+j,-d*2+j));
  end;

  Bitmap.Draw(Control.Canvas.Handle,0,0);
end;

function THIEZColor.ColorScheme(Intensity:Double):TColor;
const
  step0  = 0;
  step1  = 100;
  step2  = 200;
  step3  = 300;
  step4  = 400;
  step5  = 500;
  step6  = 600;
  step7  = 700;
  step8  = 800;
  step9  = 900;
  step10 = 1000;
  step11 = 1100;

var
  Blue, Green, Red  : double;
Begin
   Intensity := 1100*Intensity;

   case trunc(Intensity) of
     Step0..step1-1:
       begin
         Red   := -(Intensity - Step1) / (step1 - Step0);
         Green := 0.0;
         Blue  := 1.0;
       end;

     step1..step2-1:
       begin
         Red   := 0.0;
         Green := (Intensity - step1) / (step2 - step1);
         Blue  := 1.0
       end;

     step2..step3-1:
       begin
         Red   := 0.0;
         Green := 1.0;
         Blue  := -(Intensity - step3) / (step3 - step2)
       end;

     step3..step4-1:
       begin
         Red   := (Intensity - step3) / (step4 - step3);
         Green := 1.0;
         Blue  := 0.0
       end;

     step4..step5-1:
       begin
         Red   := 1.0;
         Green := -(Intensity - step5) / (step5 - step4);
         Blue  := 0.0
       end;

     step5..step6-1:
       begin
         Red   := -(Intensity - step6)/(step6 - step5)*0.15 + 0.85;    // 0.85
         Green := (Intensity - step5)/(step6 - step5)*0.5;             // 0.5
         Blue  := (Intensity - Step5)/(step6 - step5)*0.85;            // 0.85
       end;

     step6..step7-1:
       begin
         Red   := -(Intensity - step7)/(step7 - step6)*0.35 + 0.5;
         Green := 0.5;
         Blue  := 0.85;
       end;

     step7..step8-1:
       begin
         Red   := 0.5;
         Green := (Intensity - step7)/(step8 - step7)*0.35 + 0.5;
         Blue  := 0.85;
       end;

     step8..step9-1:
       begin
         Red   := 0.5;
         Green := 0.85;
         Blue  := -(Intensity - step9)/(step9 - step8)*0.35 + 0.5;
       end;

     step9..step10-1:
       begin
         Red   := (Intensity - step9)/(step10 - step9)*0.35 + 0.5;
         Green := 0.85;
         Blue  := 0.5;
       end;

     step10..step11-1:
       begin
         Red   := 0.85;
         Green := -(Intensity - step11)/(step11 - step10)*0.35 + 0.5;
         Blue  := 0.5;
       end;

     else
       Red   := 0.0;
       Green := 0.0;
       Blue  := 0.0
   end;

  result := RGB(Trunc(Red*255),Trunc(Green*255),Trunc(Blue*255));
end;

function MaxValue(const Data: array of Double): Double;
var
  I: Integer;
begin
  Result := Data[Low(Data)];
  for I := Low(Data) + 1 to High(Data) do
    if Result < Data[I] then
      Result := Data[I];
end;

function MinValue(const Data: array of Double): Double;
var
  I: Integer;
begin
  Result := Data[Low(Data)];
  for I := Low(Data) + 1 to High(Data) do
    if Result > Data[I] then
      Result := Data[I];
end;

procedure THIEZColor.RGBToHSV(const R,G,B:double;var H,S,V:double);
var
  Delta:  double;
  Min  :  double;
begin
    Min := MinValue( [R, G, B] );
    V   := MaxValue( [R, G, B] );
    Delta := V - Min;
    if   V =  0  then S := 0
    else S := Delta/V;

    if S = 0 then H := 0
    else begin
      if      R = V then H := 60 * (G - B) / Delta
      else if G = V then H := 120 + 60 * (B - R) / Delta
      else if B = V then H := 240 + 60 * (R - G) / Delta;
      if H < 0 then H := H + 360;
    end;
    S := S*255;
    H := H*255/360;
end;

procedure THIEZColor.RGBToHLS(const R,G,B:double;var H,L,S:double);
var
  Delta:  double;
  Max  :  double;
  Min  :  double;
begin
    Max := MaxValue( [R, G, B] );
    Min := MinValue( [R, G, B] );
    L := (Max + Min) / 2;
    if  (Max = Min) then begin
      S := 0;
      H := 0;
    end else if ((R = G) and (B = 0)) or ((R = B) and (G = 0)) or ((B = G) and (R = 0)) then
      S := 1;

    if (Max <> Min) then begin
      Delta := Max - Min;
      S := (Max - Min)/(Max + Min);

      if      R = Max then H := 60 * (G - B) / Delta
      else if G = Max then H := 120 + 60 * (B - R) / Delta
      else if B = Max then H := 240 + 60 * (R - G) / Delta;

      if S = 0 then H := 0;
      if H < 0 then H := H + 360;
    end;
         H := H*255/360;
         S := S*255;
end;

procedure THIEZColor.GetSysCol(X,Y:integer);
var
  k,w,rw,rh,a:integer;
begin
  w := Control.Width-Side;
  k := 1;
  rw := (w-1) div 11;
  rh := (50-K-1) div 3;
  for a := 0 to 30 do begin
    case a mod 3 of
      0 : if (X > (a div 3)*rw) and (Y > w+k+1) and (X < (a div 3)*rw+rw+1) and (Y < w+k+2+rh) then SysCol := a;
      1 : if (X > (a div 3)*rw) and (Y > w+k+1+rh) and (X < (a div 3)*rw+rw+1) and (Y < w+k+2+rh*2) then SysCol := a;
      2 : if (X > (a div 3)*rw) and (Y > w+k+1+2*rh) and (X < (a div 3)*rw+rw+1) and (Y < w+k+1+rh*3) then SysCol := a;
    end;
  end;
  if (SysCol > -1) then FNewCol := ColorSys[SysCol];
end;

procedure THIEZColor.GetPriCol(X,Y:integer);
var
  k,w,rw,rh,a:integer;
begin
  w := Control.Width-Side;
  k := 1;
  rw := (w-1) div 8;
  rh := (50-K-1) div 2;
  for a := 0 to 15 do begin
    case a mod 2 of
      0 : if (X > (a div 2)*rw) and (Y > w+k+1) and (X < (a div 2)*rw+rw+1) and (Y < w+k+2+rh) then SysCol := a;
      1 : if (X > (a div 2)*rw) and (Y > w+k+1+rh) and (X < (a div 2)*rw+rw+1) and (Y < w+k+2+rh*2) then SysCol := a;
    end;
  end;
  if (SysCol > -1) then FNewCol := ColorPrim[SysCol];
end;


procedure THIEZColor.onMouseDown(Sender: PControl; var Mouse: TMouseEventData);
var
  d,f,g,h,j,k,l,w,i:integer;
  x,y: integer;
begin
  x := Mouse.X; y := Mouse.Y;
  w := Sender.Width-Side;
  d := Trunc(w*(sqrt(0.75)-1)/2);
  f := Trunc(w + d*1.5);
  g := w-1;
  h := g-f;
  j := Trunc(w/50);
  i := Trunc(w/20);
  l := marker;
  k := 1;

  if (X >= f) and (X <= Trunc(h/3+f+1)) and (Y >= Points[0].y - l) and (Y <= Points[0].y + l) then Select := Col1
  else if (X >= Trunc(h/3+f+1)) and (X <= Trunc(h*2/3+f+1)) and (Y >= Points[1].y - l) and (Y <= Points[1].y + l) then Select := Col2
  else if (X >= Trunc(h*2/3+f+1)) and (X <= g) and (Y >= Points[2].y - l) and (Y <= Points[2].y + l) then Select := Col3
  else if (X >= Points[4].x-l) and (X <= Points[4].x +l) and (Y >= Points[4].y - l) and (Y <= Points[4].y + l) then Select := RBox
  else if (X >= Points[5].x-l) and (X <= Points[5].x +l) and (Y >= Points[5].y - l) and (Y <= Points[5].y + l) then Select := GBox
  else if (X >= Points[3].x-l) and (X <= Points[3].x +l) and (Y >= Points[3].y - l) and (Y <= Points[3].y + l) then Select := BBox
  else if (x > w) then begin
    Select := sel;
    FNewCol := Bitmap.Canvas.Pixels[x,y];
  end else if (Y > w+k+1) and (X < w) then begin
    Select := SPBox;
    if (FColType = ctPrimary) then GetPriCol(X,Y)
    else if (FColType = ctSystem) then GetSysCol(X,Y);
  end else if (X > w-i) and (Y > w+k+1-i) and (X < w) and (Y < w+k+2) then begin
    case FColType of
       ctValues  : FColType := ctSystem;
       ctSystem  : FColType := ctPrimary;
       ctPrimary : FColType := ctValues;
    end;
    DrawRects;
  end else Select := none;

  if (Select <> sel) and (Select <> SPBox) then FNewCol := Norm24BitCol(FNewCol);
  if Select <> none then begin
    Bitmap.Canvas.Brush.BrushStyle := bsSolid;
    Bitmap.Canvas.Brush.Color := FNewCol;
    Bitmap.Canvas.FillRect(MakeRect(j,j,-d*2+j,-d*2+j));
    DrawRects;
    _hi_OnEvent(_event_onSelectColor,FNewCol);
  end;
end;

procedure THIEZColor.onMouseMove(Sender: PControl; var Mouse: TMouseEventData);
var
  c,d,g,i,j,k,m,p,q,r,w,f,h,l:integer;
  corr : Double;
  Cr,Cg,Cb:byte;
  Col : TColor;
  x,y: integer;
begin
  x := Mouse.X; y := Mouse.Y;
  w := Sender.Width-Side;
  corr := w/2/255;
  c := Trunc(w/2);
  d := Trunc(w*(sqrt(0.75)-1)/2);
  g := w-1;
  i := Trunc(w/20);
  j := Trunc(w/50);
  k := 1;
  m := g-i*2;
  p := c-Trunc(Sqrt(0.75)*Corr*255)+d+j;
  q := Trunc(Sqrt(0.75)*Corr*255);
  r := c+Trunc(Sqrt(0.75)*Corr*255)+d+j;
  f := Trunc(w + d*1.5);
  h := g-f;
  l := marker;
  SysCol := -1;

  if (X >= f) and (X <= Trunc(h/3+f+1)) and (Y >= Points[0].y - l) and (Y <= Points[0].y + l) then Control.CursorLoad(0, MakeIntResource(crCross))
  else if (X >= Trunc(h/3+f+1)) and (X <= Trunc(h*2/3+f+1)) and (Y >= Points[1].y - l) and (Y <= Points[1].y + l) then Control.CursorLoad(0, MakeIntResource(crCross))
  else if (X >= Trunc(h*2/3+f+1)) and (X <= g) and (Y >= Points[2].y - l) and (Y <= Points[2].y + l) then Control.CursorLoad(0, MakeIntResource(crCross))
  else if (X >= Points[4].x-l) and (X <= Points[4].x +l) and (Y >= Points[4].y - l) and (Y <= Points[4].y + l) then Control.CursorLoad(0, MakeIntResource(crCross))
  else if (X >= Points[5].x-l) and (X <= Points[5].x +l) and (Y >= Points[5].y - l) and (Y <= Points[5].y + l) then Control.CursorLoad(0, MakeIntResource(crCross))
  else if (X >= Points[3].x-l) and (X <= Points[3].x +l) and (Y >= Points[3].y - l) and (Y <= Points[3].y + l) then Control.CursorLoad(0, MakeIntResource(crCross))
  else if (Y > w+k+1) and (X < w) and (FColType <> ctValues) then Control.CursorLoad(0, MakeIntResource(crHandPoint))
  else if (X > w-i) and (Y > w+k+1-i) and (X < w) and (Y < w+k+2) then Control.CursorLoad(0, MakeIntResource(crHandPoint))
  else if (x > w) then Control.CursorLoad(0, MakeIntResource(crCross))
  else Control.CursorLoad(0, MakeIntResource(crDefault));

  if (Select = sel) and (x > w+1) then FNewCol := Bitmap.Canvas.Pixels[x,y];

  Col := Norm24BitCol(FNewCol);
  Cr := GetRValue(Col);
  Cg := GetGValue(Col);
  Cb := GetBValue(Col);
  case Select of
    Col1 : begin
             if y > g-i then y := g-i;
             if Y < i then y := i;
             FNewCol := RGB(255-Trunc((y-i)*255/m),Cg,Cb);
           end;

    Col2 : begin
             if y > g-i then y := g-i;
             if Y < i then y := i;
             FNewCol := RGB(Cr,255-Trunc((y-i)*255/m),Cb);
           end;

    Col3 : begin
             if y > g-i then y := g-i;
             if Y < i then y := i;
             FNewCol := RGB(Cr,Cg,255-Trunc((y-i)*255/m));
           end;

    RBox : begin
             if x > c+d+j then x := c+d+j;
             if x < p then x := p;
             FNewCol := RGB(255-Trunc((x-p)*255/q),Cg,Cb);
           end;

    GBox : begin
             if x < c+d+j then x := c+d+j;
             if x > r then x := r;
             FNewCol := RGB(Cr,Trunc((x-r)*255/q)-1,Cb);
           end;

    BBox : begin
             if y < k then y := k;
             if y > c then y := c;
             FNewCol := RGB(Cr,Cg,Trunc((k-y)*255/(c-k))-1);
           end;

    SPBox: begin
             if (FColType = ctPrimary) then begin GetPriCol(X,Y)
             end else if (FColType = ctSystem) then GetSysCol(X,Y);
           end;
  end;

  if Select <> none then begin
    Bitmap.Canvas.Brush.BrushStyle := bsSolid;
    Bitmap.Canvas.Brush.Color := FNewCol;
    Bitmap.Canvas.FillRect(MakeRect(j,j,-d*2+j,-d*2+j));
    DrawRects;

    _hi_OnEvent(_event_onSelectColor,FNewCol);
  end;

end;

procedure THIEZColor.onMouseUp(Sender: PControl; var Mouse: TMouseEventData);
begin
  Select := none;
end;

function THIEZColor.GetColorName(Col:TColor):TColorSyn;
var
  I,Dif : integer;
  R,G,B : byte;
begin
  Dif := 10*Variance;
  R := GetRValue(Col);
  G := GetGValue(Col);
  B := GetBValue(Col);
  for I := 0 to MaxColor do begin
     if (dif > abs(ColorRef[I][0]-R)+abs(ColorRef[I][1]-G)+abs(ColorRef[I][2]-B)) then begin
       dif := abs(ColorRef[I][0]-R)+abs(ColorRef[I][1]-G)+abs(ColorRef[I][2]-B);
       Result.ColName := ColorName[I];
     end;
  end;
  if (Dif > 6*Variance) then begin
    Result.ColName := '';
    Result.ColDiff := 2;
  end else if (Dif > 3*Variance) and (Dif <= 6*Variance) then Result.ColDiff := 1
  else Result.ColDiff := 0;
end;


end.
